"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Build = void 0;
const fs_1 = __importDefault(require("fs"));
const path_1 = __importDefault(require("path"));
const shelljs_1 = __importDefault(require("shelljs"));
const Constant = __importStar(require("./constant"));
async function Build(src, dst, docsRelativePath) {
    const navList = [];
    const dirs = fs_1.default.readdirSync(src);
    dirs.sort((a, b) => {
        const _a = Number(a.split(".")[0]);
        const _b = Number(b.split(".")[0]);
        if (_a < _b) {
            return -1;
        }
        if (_a > _b) {
            return 1;
        }
        return 0;
    });
    for (const dir of dirs) {
        buildProblem(path_1.default.join(src, dir), path_1.default.join(dst, dir), dir);
        navList.push({ [dir]: path_1.default.join(docsRelativePath, dir, "index.md") });
    }
    return navList;
}
exports.Build = Build;
function buildProblem(src, dst, filename) {
    const mdTemplate = `# ${filename}

${makeStatementContent(src, dst)}

${makeSolutionContent(src, dst)}

`;
    fs_1.default.writeFileSync(path_1.default.join(dst, "index.md"), mdTemplate);
}
function makeStatementContent(src, dst) {
    const statementContent = (() => {
        const getContent = (filename) => {
            return fs_1.default
                .readFileSync(path_1.default.join(src, filename))
                .toString()
                .replace(/<pre>/g, "<pre><code>")
                .replace(/<pre><code>\n/g, "<pre><code>")
                .replace(/<\/pre>/g, "</code></pre>")
                .replace(/\*/g, "\\*")
                .split("\n")
                .filter((s) => s !== "")
                .map((s) => "    " + s)
                .join("\n");
        };
        const statementContent = {
            en_US: getContent(Constant.StatementFileName.en_US),
            zh_CN: getContent(Constant.StatementFileName.zh_CN),
        };
        return statementContent;
    })();
    shelljs_1.default.rm("-R", `${dst}/problem-assets/problem.json`);
    shelljs_1.default.rm("-R", `${dst}/*.md`);
    return `
## Statement

=== "简体中文"
${statementContent.zh_CN}

=== "English"
${statementContent.en_US}

`;
}
function makeSolutionContent(src, dst) {
    shelljs_1.default.rm("-R", `${dst}/*.cpp`);
    return `
## Solution

=== "Cpp"
\`\`\`cpp
--8<-- "${src}/solution.cpp"
\`\`\`

`;
}
//# sourceMappingURL=mkdocs.js.map